Skip to main content

Depth-first-search - Medium Level - Question 1

Depth-first-search - Medium Level - Question 1


Leetcode 113. Path Sum II

Given the root of a binary tree and an integer targetSum, return all root-to-leaf paths where each path's sum equals targetSum.

A leaf is a node with no children.

Constraints:

The number of nodes in the tree is in the range [0, 5000].

-1000 <= Node.val <= 1000

-1000 <= targetSum <= 1000


Analysis:

If the root is null, we can stop searching.

Starting with the root, we only have two ways to go: the left child and the right child.

Once we move on to the next step, we need to update the conditions: the sum and the path.

When the node is a leaf, we should check the sum, to see whether it reaches 0 or not (here we use the targetSum - node.val. You can use the sum of all the nodes on the path, but need one more variable).

If the sum is 0, then we find one path, so we can save it in the final answer; if not, we will stop this route and continue the search with other routes.

Since we switch from on path to the other (from the left child to the right child, we just need to pop out the last element in the path, so a path with reference (or in macro) can be used.


See the code below:


/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode(int x) : val(x), left(NULL), right(NULL) {}
 * };
 */
class Solution {
public:
    vector<vector<int>> pathSum(TreeNode* root, int sum) {
        vector<vector<int>> res;
        vector<int> path;
        dsf(root, sum, res, path);
        return res;
    }
private:
    void dsf(TreeNode* r, int s, vector<vector<int>>& res, vector<int>& ps){
        if(!r) return;
        ps.push_back(r->val);
        if(!r->left && !r->right && s == r->val) res.push_back(ps);
        dsf(r->left, s - r->val, res, ps);
        dsf(r->right, s - r->val, res, ps);
        ps.pop_back();
    }
};


Upper Layer


 

Comments

Popular posts from this blog

Binary Search - Example

Binary Search - Example Leetcode 35  Search Insert Position Given a sorted array of distinct integers and a target value, return the index if the target is found. If not, return the index where it would be if it were inserted in order. You must write an algorithm with O(log n) runtime complexity. Constraints: 1 <= nums.length <= 10^4 -10^4 <= nums[i] <= 10^4 nums contains distinct values sorted in ascending order. -10^4 <= target <= 10^4 Analysis: The array is sorted, so we just need to run a routine binary search. Make a guest first, then based on the guessed result, we can adjust the search range. See the code below: class Solution { public: int searchInsert(vector<int>& nums, int target) { int left = 0, right = nums.size(); while(left < right) { int mid = left + (right - left) / 2; if(nums[mid] < target) left = mid + 1; else right = mid; } return left; } }; If you know t...

Graph Question - Hard Level - Question 1

2246. Longest Path With Different Adjacent Characters You are given a tree (i.e. a connected, undirected graph that has no cycles) rooted at node 0 consisting of n nodes numbered from 0 to n - 1. The tree is represented by a 0-indexed array parent of size n, where parent[i] is the parent of node i. Since node 0 is the root, parent[0] == -1. You are also given a string s of length n, where s[i] is the character assigned to node i. Return the length of the longest path in the tree such that no pair of adjacent nodes on the path have the same character assigned to them. Constraints: n == parent.length == s.length 1 <= n <= 10^5 0 <= parent[i] <= n - 1 for all i >= 1 parent[0] == -1 parent represents a valid tree. s consists of only lowercase English letters. Analysis For this question, we need to construct a graph, or more specifically, a n-nary tree. How to construct the graph/tree? What we only know is the parent array. So we need to go through the parent array and constr...